/**
 * 注册送会员
 */
if (_cao('register_gift')['is_register_gift']) {
    add_action('user_register', function ($user_id) {
        update_user_meta($user_id, 'cao_user_type', _cao('register_gift')['_level']);
        $time = date("Y-m-d",strtotime('+'._cao('register_gift')['_day'].' day'));
        update_user_meta($user_id, 'cao_vip_end_time', $time);
       
    });
}
// +----------------------------------------------------------------------
// | 推广注册送会员 [ 推广者达到目标人数赠送想对应的天数会员 ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020~2021 https://www.yfxw.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed 本功能有骚老板赞助开发,尊重赞助者版权,感谢各位的支持
// +----------------------------------------------------------------------
// | Sponsor: 骚老板 <QQ:15001904>
// +----------------------------------------------------------------------
 
//判断是否开启了这个功能
if (_cao('extension_register')) {
    //判断是是推广链接
      if (!empty($_GET['aff'])) {
        //开启缓存
        session_start();
        //获取推广者ID
        $aff_id = absint($_GET['aff']);
        //将推广者ID记录缓存当中
        $_SESSION['aff_id']=$aff_id;
      }
function extension_register() {
    global $wpdb;
        // 获取推广者ID
        $aff_id = $_SESSION['aff_id'];
        //获取推广者会员类型
        $type=get_user_meta($aff_id, 'cao_user_type', true);
        //判断永会不参与赠送
        if($type != 'boosvip'){
        //根据推广者ID获取推广总人数
        $ref_nums = $wpdb->get_var($wpdb->prepare("SELECT COUNT(user_id) FROM {$wpdb->usermeta} WHERE meta_key=%s AND meta_value=%s", 'cao_ref_from', $aff_id));
        //这个是为了注册成功后配置＋1同步人数
        $ref_nums++;
        //获取后台配置推广项
         $extension=_cao('extension_register');
        //根据字段vip_people对数组$extension进行降序排列
        $people = array_column($extension,'vip_people');
        array_multisort($people,SORT_DESC,$extension);
        //循环遍历查找对应的推广人数赠送会员
        foreach ($extension as $k=>$v){
        //判断是否达标到推广人数
        if($ref_nums==$v['vip_people']){
        //判断是否是会员,不是则更改为会员
            if($type != 'vip'){
                //获取会员到期时间
                $vip_end_time = date("Y-m-d",time());
                //更新用户会员类型
                update_user_meta($aff_id, 'cao_user_type', $v['vip_level']);
            }else{
                //获取会员到期时间
                $vip_end_time=get_user_meta($aff_id, 'cao_vip_end_time', true);
            }
            //改变到期时间
            $endtime = date("Y-m-d",strtotime($vip_end_time));
            //增加会员时长
            $time = date("Y-m-d",strtotime($endtime.'+'.$v['vip_day'].' day'));
            //更新会员时长
            update_user_meta($aff_id, 'cao_vip_end_time', $time);
            //执行完后退出循环
            break;
        }
            } 
        }
    }
}

add_action('user_register','extension_register');
